##############################################################################
# REPLACE STRINGS
#
# USED NAMES:
# samplename (RingSPK)		= PkgName
# sampledir (ksm-ringspk)	= pkg-dirname = pkg-filename (ksm-xxx)
# sampleconf (ringspk)		= config/include file name (no extension)
# sampledm (ringspkd)		= the daemon (rc-script, rc-link, systemd.service)
# sample (ringspk)		= all others
##############################################################################

# Specfile for RingSPK

%define name		ksm-ringspk
%define version		0.0.1
%define release		0.0.0
%define _arch		i586
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _sysddir	/etc/systemd/system
%define _uxbindir	/usr/bin
%define _uxsbindir	/usr/sbin
%define _bindir		/usr/local/bin
%define _sbindir	/usr/local/sbin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	RingSPK program
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Productivity/Other
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	ringspkpkg,ringspkcapab
Requires:	ksm-lib-sh >= 5.0.1-0.0.0
#Requires:	ksm-ringspk = %{version}-%{release}	# if lang pkg
#Provides:	ringspkd
#Conflicts:	ringspkd-other,libringspk == 0.0.0
#Obsoletes:	myringspkd

%description
This package contains programs for ringing the pc-spkeaker.
The package contains the following programs:

 ringspk

#----------------- ONLY SOURCE PACKAGES - DEL IF NO SOURCE -------------------
#%prep
#%setup
#%{__tar} -xpzf %{_srcfile}

#%build
#%configure or ./configure
#make CFLAGS="$RPM_OPT_FLAGS"

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/ringspk.conf
#%config %{_confdir}/ringspk.conf
#%config %{_scnfdir}/ringspk
#%attr(644,root,root)%{_confdir}/ringspk.conf
#%attr(644,root,root)%{_scnfdir}/ringspk
#%attr(644,root,root)%{_confdir}/ringspk.incl.rpmnew

#%attr(744,root,root)%{_rcdir}/ringspkd
#%attr(777,root,root)%{_sbindir}/rcringspkd
#%attr(744,root,root)%{_sbindir}/ringspkd.sh

%attr(755,root,root)%{_bindir}/ringspk

%{_datadir}/RELEASE
%{_datadir}/VERSION
#%attr(744,root,root)%{_datadir}/ringspkd.rc
#%{_datadir}/ringspkd.service

#/usr/share/applications/ringspk.desktop

#%{_icondir}/16x16/apps/ringspk.png
#%{_icondir}/22x22/apps/ringspk.png
#%{_icondir}/32x32/apps/ringspk.png
#%{_icondir}/48x48/apps/ringspk.png
#%{_icondir}/64x64/apps/ringspk.png
#%{_icondir}/96x96/apps/ringspk.png
#%{_icondir}/128x128/apps/ringspk.png
#%{_icondir}/256x256/apps/ringspk.png
#%{_icondir}/512x512/apps/ringspk.png
#/usr/share/pixmaps/ringspk.png

%docdir %{_man1dir}
%{_man1dir}/ringspk.1.gz

%docdir %{_man8dir}
#%{_man8dir}/ringspkd.sh.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
%{_docdir}/README.de
%{_docdir}/ringspk.pas

#---------------------- ORDER OF SCRIPTLETS ----------------------------------
# O=old pkg, N=new pkg

# INSTALL:
# 1. Run %pre section of N		(Arg is 1)
# 2. Install files from N
# 3. Run %post section of N		(Arg is 1)

# UNINSTALL:
# 1. Run %preun section of O		(Arg is 0)
# 2. Delete files from O
# 3. Run %postun section of O		(Arg is 0)

# UPGRADE:
#  1. Run %pre section of O		(Arg is 2)
#  2. Install files from N
#  3. Run %post section of N		(Arg is 2)
#  4. Execute install. triggers (%triggerin in other pkgs) set off by install N
#  5. Execute installation triggers of N
#  6. Execute uninstallation triggers (%triggerun) of O
#  7. Execute uninstallation triggers (of other pkgs) set off by uninstall O
#  8. Run %preun section of O		(Arg is 1)
#  9. Delete files from O not contained in N
# 10. Run %postun section of O		(Arg is 1)

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# backup config files
#test -e %{_confdir}/ringspk.conf && cp %{_confdir}/ringspk.conf %{_confdir}/ringspk.conf.rpmsave
#test -e %{_scnfdir}/ringspk && cp %{_scnfdir}/ringspk %{_scnfdir}/ringspk.rpmsave

# disable ringspk daemon and stop ringspkd
#test -x %{_bindir}/toggleringspk && %{_bindir}/toggleringspk -d -q > /dev/null 2>&1
#test -x %{_rcdir}/ringspkd && %{_rcdir}/ringspkd stop -q > /dev/null 2>&1

# rm links
#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
#rm -f %{_libdir}/libfuncstd-sh

# uninstall desktop files
#xdg-desktop-menu uninstall \
#	/usr/share/applications/ringspk.directory \
#	/usr/share/applications/ringspk.desktop \
#	/usr/share/applications/ringspk-admin.desktop

# INIT SCRIPT/SYSTEMD UNIT - uninstall RingSPK
#if [ -d %{_sysddir} ]; then				# systemd
#	if [ -e %{_sysddir}/ringspkd.service ]; then
#		systemctl stop ringspkd.service
#		systemctl disable ringspkd.service
#		rm %{_sysddir}/ringspkd.service
#		systemctl daemon-reload
#	fi
#else							# SysV init
#	if [ -e %{_rcdir}/ringspkd ]; then
#		test -x %{_rcdir}/ringspkd && %{_rcdir}/ringspkd stop > /dev/null 2>&1
#		insserv -r ringspkd > /dev/null 2>&1
#		rm -f %{_rcdir}/ringspkd
#		rm -f %{_sbindir}/rcringspkd
#	fi
#fi

#if [ "$1" == 1 ]; then					# install package
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# Definition of vars
# set config pathname. config file needs a version at first cnfvar!
#cf=%{_confdir}/ringspk.conf
#cnfvars=$(grep -v '^#' $cf | grep '[[:alnum:]]' | grep -v '\[' | cut -sd '=' -f1)
#cnfvars=$(echo $cnfvars | cut -d ' ' -f2-)
#
#incf=%{_confdir}/ringspk.incl

# update icon cache
#gtk-update-icon-cache "/usr/share/icons/hicolor/"
#gtk-update-icon-cache-2.0 "/usr/share/icons/hicolor/"
#gtk-update-icon-cache-3.0 "/usr/share/icons/hicolor/"

# enable ringspk daemon
#test -x %{_bindir}/toggleringspk && %{_bindir}/toggleringspk -e -q > /dev/null 2>&1

# set links
#ln -sf /usr/bin/prog %{_bindir}/myprog
#ln -sf %{_libdir}/libfuncstd-sh-%{version} %{_libdir}/libfuncstd-sh

# handle include files
#if [ -e "$incf" ]; then
#	rm $incf.rpmnew
#else
#	mv $incf.rpmnew $incf
#	echo "Check $incf"
#fi

# install desktop files
#xdg-desktop-menu install --novendor \
#	/usr/share/applications/ringspk.directory \
#	/usr/share/applications/ringspk.desktop \
#	/usr/share/applications/ringspk-admin.desktop

# add a (new) template to ringspk
#f=/.../ringspk						# pathname of file
#templ=%{_datadir}/ringspk.add				# template in datadir
#tmpf=/tmp/ringspk					# tempfile
#flag=ksm-ringspk						# flag for entries
#if [ -e $f ]; then					# file exist
#	grep -q $flag $f				# look for flag
#	ret=$?
#	if [ $ret -ne 0 ]; then				# no flag found
#		cat $templ >> $f			# add entries
#	else						# flag found
#		cat $f | grep $flag > $tmpf		# get add from file
#		cmp -s $tmpf $templ			# cmp add vs. templ
#		ret=$?
#		if [ $ret -ne 0 ]; then			# templ is new
#			cat $f | grep -v $flag > $tmpf	# rm add from file
#			cp $tmpf $f
#			cat $templ >> $f		# add new entries
#		fi
#		rm -f $tmpf
#	fi
#	echo "Package ksm-ringspk: users should source $f"
#else
#	echo "Package ksm-ringspk: File $f not found!"
#fi

# INIT SCRIPT/SYSTEMD UNIT - install RingSPK
#if [ -d %{_sysddir} ]; then				# systemd
#	cp --preserve=mode %{_datadir}/ringspkd.service %{_sysddir}/
#	systemctl daemon-reload
#	systemctl enable ringspkd.service
#	echo "ringspkd is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start ringspkd within yast or manual with:"
#	echo "systemctl start ringspkd.service"
#else							# SysV init
#	cp --preserve=mode %{_datadir}/ringspkd.rc %{_rcdir}/ringspkd
#	ln -sf %{_rcdir}/ringspkd %{_sbindir}/rcringspkd
#	insserv ringspkd > /dev/null 2>&1
#	echo "ringspkd is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start ringspkd within yast or manual with rcringspkd start"
#fi

# install/update all users rc files
#updcmd="%{_bindir}/update-ringspk -q"
# for all users below /home/ do:
#usr=$(/usr/bin/grep /home/ /etc/passwd | /usr/bin/cut -d : -f 1)
#for u in $usr; do
#	if [ -e /home/${u}/.$ringspkrc ]; then		# if exist rc file
#		/bin/su $u -c "$updcmd"
#	fi
#done
#echo "Package ksm-ringspk: All users rc files have been updated"
#echo "Package ksm-ringspk: All existing users rc files have been updated"

#if [ "$1" == 1 ]; then					# install package
#	echo "Configure $cf"
#else							# upgrade package
#	# update global conf
#	if [ -e $cf.rpmsave ]; then
#		#cp $cf $cf.rpmnew
#		. $cf
#		. $cf.rpmsave
#
#		# update conf vars START -------------------------------------
#		if [ -x %{_bindir}/replcnfvar ]; then
#			for c in $cnfvars; do
#				t="\$$c"
#				eval s="$t"
#				s=\"$s\"
#				%{_bindir}/replcnfvar $cf $c "$s"
#			done
#		else
#			echo "Package ksm-ringspk: Error - cmd replcnfvar not found or not executable!" >&2
#			echo "Package ksm-ringspk: Conf file not updated!" >&2
#		fi
#		# update conf vars STOP --------------------------------------
#
#		# update array vars START ------------------------------------
#		# array var MainArr (contignous index from 0)
#		cnt=${#MainArr[@]}			# max members of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any member in use?
#			while [ "$i" -lt $cnt ]; do
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#				let ++i
#			done
#		fi
#
#		# array var MainArr (contignous index from 1)
#		cnt=${#MainArr[@]}			# max members of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any member in use?
#			while [ "$i" -lt $cnt ]; do
#				let ++i
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi
#		# update array vars STOP -------------------------------------
#
#		# compare new conf vars <--> old conf vars
#		diff $cf $cf.rpmsave > /dev/null 2>&1
#		ret=$?
#		if [ "$ret" -eq 0 ]; then
#			rm $cf.rpmsave
#		else
#			echo "Check $cf"
#		fi
#	fi
#fi
# if libraries contained:
#ldconfig
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

#if [ "$1" == 0 ]; then					# remove package
	# backup config files
	#test -e %{_confdir}/ringspk.conf && cp %{_confdir}/ringspk.conf %{_confdir}/ringspk.conf.rpmsave
	#test -e %{_scnfdir}/ringspk && cp %{_scnfdir}/ringspk %{_scnfdir}/ringspk.rpmsave

	# disable ringspk daemon and stop ringspkd
	#test -x %{_bindir}/toggleringspk && %{_bindir}/toggleringspk -d -q > /dev/null 2>&1
	#test -x %{_rcdir}/ringspkd && %{_rcdir}/ringspkd stop -q > /dev/null 2>&1

	# rm links
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
	#rm -f %{_libdir}/libfuncstd-sh

	# uninstall desktop files
	#xdg-desktop-menu uninstall \
	#	/usr/share/applications/ringspk.directory \
	#	/usr/share/applications/ringspk.desktop \
	#	/usr/share/applications/ringspk-admin.desktop

	# remove entries from file ringspk
	#f=/.../ringspk					# pathname of file
	#tmpf=/tmp/ringspk				# tempfile
	#flag=ksm-ringspk				# flag for entries
	#ret=0
	#if [ -e $f ]; then
	#	grep -q $flag $f			# look for flag
	#	ret=$?
	#	if [ $ret -eq 0 ]; then			# flag found
	#		cat $f | grep -v $flag > $tmpf	# rm add from file
	#		cp $tmpf $f
	#		rm -f $tmpf
	#	fi
	#else
	#	echo "Package ksm-ringspk: File $f not found!"
	#fi

	# INIT SCRIPT/SYSTEMD UNIT - uninstall RingSPK
	#if [ -d %{_sysddir} ]; then			# systemd
	#	if [ -e %{_sysddir}/ringspkd.service ]; then
	#		systemctl stop ringspkd.service
	#		systemctl disable ringspkd.service
	#		rm %{_sysddir}/ringspkd.service
	#		systemctl daemon-reload
	#	fi
	#else						# SysV init
	#		test -x %{_rcdir}/ringspkd && %{_rcdir}/ringspkd stop > /dev/null 2>&1
	#		insserv -r ringspkd > /dev/null 2>&1
	#		rm -f %{_rcdir}/ringspkd
	#		rm -f %{_sbindir}/rcringspkd
	#	fi
	#fi
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

# update icon cache
#gtk-update-icon-cache "/usr/share/icons/hicolor/"

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/ksm-ringspk
#else							# upgrade package
fi
exit 0

%changelog
* Mon Feb 19 2024 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.0.0
- The package has been revised/improved.

* Mon Feb 19 2024 Repomaster <repomaster@kaesmann-online.de> 0.0.0-0.0.0
- This is the 1. version.
- The package contains following programs:
  ringspk:	Ring the pc-speaker
